CON

    _clkmode        = xtal1 + pll16x
    _xinfreq        = 5_000_000                 


{{'WheelSpeed' ramp methods added
 V2 use global variables which initialize to zero }}

OBJ 
             pst     : "Parallax Serial Terminal" 
                                                           
VAR

  long  stack[60] ', NumberOfSteps,TotalTime,ComputedTime,T,OneTenthTime,RSteps,RComputedTime,StepAddUp,TimeAddUp
  byte  cog,x,y ',idx        

PUB Start_B(a, b)  | L, R        
                                               
      L := b
      R := a    
 
      Stop                                                      
   '   cognew(Raymans_StyleLS(L), @stack[1])
      cognew(Raymans_StyleLS(1018), @stack[1])
      Stop                                                      
    '  cognew(Raymans_StyleLS(R), @stack[1])
      cognew(Raymans_StyleRS(742), @stack[30])
                                                                                
PUB stop

    If cog 
      cogstop(cog)  

PUB Raymans_StyleLS(L) | i,NumberOfSteps,TotalTime,ComputedTime,T,OneTenthTime,RSteps,RComputedTime,StepAddUp,TimeAddUp,idx 

    dira[8..11]~~                                'basic calculations
    NumberOfSteps :=  L '2018                    'running speed
    TotalTime := clkfreq * 4                     'time allowed for ramping
    ComputedTime := TotalTime / NumberOfSteps    'cramming more steps into the same amount of time speeds up
    T := cnt                                     'ramping calculations
                                                  
    repeat NumberOfSteps
      T += ComputedTime             'ComputedTime = 1066666                
      NewStepLS(i++) 
      waitcnt(T)
                     

PUB Raymans_StyleRS(R) | i, NumberOfSteps,TotalTime,ComputedTime,T,OneTenthTime,RSteps,RComputedTime,StepAddUp,TimeAddUp,idx 

    dira[15..12]~~                                'basic calculations
    NumberOfSteps :=  R '2018                    'running speed
    TotalTime := clkfreq * 4                     'time allowed for ramping
    ComputedTime := TotalTime / NumberOfSteps    'cramming more steps into the same amount of time speeds up
    T := cnt                                     'ramping calculations
                                      
    repeat NumberOfSteps
      T += ComputedTime             'ComputedTime = 1066666                
      NewStepRS(i++) 
      waitcnt(T)
                                      
PRI NewStepLS(n)
  n := n // 4
  case n
    0:
      outa[8..11]:=%1100
    1:
      outa[8..11]:=%0110   
    2:
      outa[8..11]:=%0011   
    3:
      outa[8..11]:=%1001                                        

PRI NewStepRS(n)
  n := n // 4
  case n
    0:
      outa[15..12]:=%1100
    1:
      outa[15..12]:=%0110   
    2:
      outa[15..12]:=%0011   
    3:
      outa[15..12]:=%1001                                        
 